---
title: SubmitEvent
slug: Web/API/SubmitEvent
tags:
  - API
  - Form Submission
  - Forms
  - HTML DOM
  - Interface
  - Reference
  - SubmitEvent
  - Web
  - events
  - submit
---
<p>{{APIRef("HTML DOM")}}</p>

<p>The <code><strong>SubmitEvent</strong></code> interface defines the object used to represent an {{Glossary("HTML")}} form's {{domxref("HTMLFormElement.submit_event", "submit")}} event. This event is fired at the {{HTMLElement("form")}} when the form's submit action is invoked.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("SubmitEvent.SubmitEvent", "SubmitEvent()")}}</dt>
 <dd>Creates and returns a new <code>SubmitEvent</code> object whose {{domxref("Event.type", "type")}} and other options are configured as specified. Note that currently the only valid <code>type</code> for a <code>SubmitEvent</code> is <code>submit</code>.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>In addition to the properties listed below, this interface inherits the properties of its parent interface, {{domxref("Event")}}.</em></p>

<dl>
 <dt>{{domxref("SubmitEvent.submitter", "submitter")}} {{ReadOnlyInline}}</dt>
 <dd>An {{domxref("HTMLElement")}} object which identifies the button or other element which was invoked to trigger the form being submitted.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>While <code>SubmitEvent</code> offers no methods of its own, it inherits any specified by its parent interface, {{domxref("Event")}}.</em></p>

<h2 id="Examples">Examples</h2>

<p>In this example, a shopping cart may have an assortment of different submit buttons depending on factors such as the user's settings, the shop's settings, and any minimum or maximum shopping card totals established by the payment processors. Each of the submit elements' {{domxref("Element.id", "id")}} is used to identify which payment processor the button corresponds to.</p>

<pre class="brush: js notranslate">let form = document.querySelector("form");
form.addEventListener("submit", (event) =&gt; {
  let submitter = event.submitter;
  let handler = submitter.id;

  if (handler) {
    processOrder(form, handler);
  } else {
    showAlertMessage("An unknown or unaccepted payment type was selected. Please try again.", "OK");
  }
});

</pre>

<p>The handler ID is obtained by using the <code>submit</code> event's {{domxref("SubmitEvent.submitter", "submitter")}} property to get the submit button, from which we then get the ID. With that in hand, we can call a <code>processOrder()</code> function to handle the order, passing along the form and the handler ID.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', "form-control-infrastructure.html#submitevent", "SubmitEvent")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.SubmitEvent")}}</p>
